=== debian/changelog ===
gnss-sdr (0.0.6-2) unstable; urgency=medium

  * Bumps gnuradio version.
  * Added cryptographic signature verification.
  * Standards-Version bumped to 3.9.7
  * Added hardening options.

 -- Carles Fernandez <carles.fernandez@cttc.es>  Tue, 26 Apr 2016 16:15:51 +0200

gnss-sdr (0.0.6-1) unstable; urgency=medium

  * Initial release. (Closes: #712838)

 -- Carles Fernandez <carles.fernandez@cttc.es>  Wed, 02 Sep 2015 18:21:45 +0200
